
function [X,Pm,AttMtx] = EBDMPre(X,Pm)

% calculate distance matrices for each attribute with attribute weighting

ValNum=zeros(Pm.Xwd,1);
for i=1:Pm.Xwd
    ValNum(i)=max(X(:,i));
end

Weight=zeros(1,Pm.Xwd);
for i=1:Pm.Xwd
    Weight(i) = AccEntropy(X(:,i),ValNum(i),Pm.Xlth);
end
Weight=Weight/sum(Weight);

AttMtx=cell(Pm.Xwd,1);
for i=1:Pm.O
    DistMtx=zeros(ValNum(i));   
    for h=1:ValNum(i)
        for m=1:ValNum(i)
            if m>h
                PoolList1=find(X(:,i)<=m);
                PoolList2=find(X(:,i)>=h);
                PoolList=intersect(PoolList1,PoolList2);
                OR = AccEntropy(X(PoolList,i),ValNum(i),Pm.Xlth);
                OA = AccEntropy((1:ValNum(i)),ValNum(i),ValNum(i));
                DistMtx(h,m)=Weight(i)*OR/OA;
                DistMtx(m,h)=DistMtx(h,m);
            end
        end
    end
    AttMtx{i}=DistMtx;
end

if Pm.O<Pm.Xwd
    for i=Pm.O+1:Pm.Xwd
        DistMtx=zeros(ValNum(i));
        for h=1:ValNum(i)
            for m=1:ValNum(i)
                if m>h
                    PoolList1=find(X(:,i)==m);
                    PoolList2=find(X(:,i)==h);
                    PoolList=[PoolList1;PoolList2];
                    OR = AccEntropyN(X(PoolList,i),ValNum(i),Pm.Xlth);
                    OA = AccEntropyN((1:ValNum(i)),ValNum(i),ValNum(i));
                    DistMtx(h,m)=Weight(i)*OR/OA;
                    DistMtx(m,h)=DistMtx(h,m);
                end
            end
        end
        AttMtx{i}=DistMtx;
    end
end

end

